'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RtcSdk = exports.RoomContainer = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _package = require('../package.json');

var _package2 = _interopRequireDefault(_package);

var _jsSdk = require('@555platform/555-js-sdk');

var _jsSdk2 = _interopRequireDefault(_jsSdk);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

console.log("iris-react-sdk : v" + _package2.default.version);

var RtcSdk = {};
var PSTN = {};
var localStream = "";

RtcSdk.init = function (config) {
  console.log("RtcSdk : init : " + JSON.stringify(config));

  PSTN = new _jsSdk2.default.PSTN(config);

  RtcSdk.createStream = PSTN.createStream;
  RtcSdk.getMediaDevices = PSTN.getMediaDevices;
  RtcSdk.requestMediaPermission = PSTN.requestMediaPermission;
  RtcSdk.stopMediaStream = PSTN.stopMediaStream;
};

RtcSdk.connect = function (token, routingId) {

  console.log("555React :: RtcSdk.connect called ");

  if (PSTN) {

    PSTN.on(_jsSdk2.default.Events.LOCAL_STREAM, function (stream) {
      console.log("555React :: localStream :: ", stream);
      localStream = stream;
      RtcSdk.onLocalStream(stream);
    });

    PSTN.on(_jsSdk2.default.Events.CONNECTED, function () {
      console.log("555React :: 555 connection successful");
      RtcSdk.onConnected();
    });

    PSTN.on(_jsSdk2.default.Events.ERROR, function (errorCode, errorMessage) {
      console.error("555React :: 555 connection failed");
      RtcSdk.onError(errorCode, errorMessage);
    });

    PSTN.on(_jsSdk2.default.Events.DISCONNECTED, function () {
      console.log("555React :: 555 connection closed");
      RtcSdk.onDisconnected();
    });

    PSTN.on(_jsSdk2.default.Events.NOTIFICATION, function (notificationInfo) {
      console.log("555React :: onNotification :: " + JSON.stringify(notificationInfo));
      RtcSdk.onNotification(notificationInfo);
    });

    PSTN.on(_jsSdk2.default.Events.RECONNECTING, function () {
      console.log("555React :: onReconnecting");
      RtcSdk.onReconnecting();
    });

    PSTN.init(token, routingId);
  }
};

RtcSdk.disconnect = function () {
  PSTN.close();
};

RtcSdk.rejectCall = function (notificationInfo) {
  PSTN.reject(notificationInfo);
};

/**
* Create a room container
*/

var RoomContainer = function (_Component) {
  _inherits(RoomContainer, _Component);

  // Constructor
  function RoomContainer(props) {
    _classCallCheck(this, RoomContainer);

    var _this = _possibleConstructorReturn(this, (RoomContainer.__proto__ || Object.getPrototypeOf(RoomContainer)).call(this, props));

    console.log(' 555RoomContainer :: constructor');

    _this._endSession = _this._endSession.bind(_this);
    _this.endSession = _this.endSession.bind(_this);
    _this.audioMuteToggle = _this.audioMuteToggle.bind(_this);
    _this.sendDTMFTone = _this.sendDTMFTone.bind(_this);
    _this.pstnHold = _this.pstnHold.bind(_this);
    _this.pstnUnHold = _this.pstnUnHold.bind(_this);
    _this.pstnHangup = _this.pstnHangup.bind(_this);
    _this.pstnMerge = _this.pstnMerge.bind(_this);

    _this.pstnSession = {};
    return _this;
  }

  _createClass(RoomContainer, [{
    key: 'listenToSessionEvents',
    value: function listenToSessionEvents(session) {
      this.pstnSession = session;
      session.on(_jsSdk2.default.Events.SESSION_CREATED, this._onSessionCreated.bind(this));
      session.on(_jsSdk2.default.Events.SESSION_JOINED, this._onSessionJoined.bind(this));
      session.on(_jsSdk2.default.Events.SESSION_CONNECTED, this._onSessionConnected.bind(this));
      session.on(_jsSdk2.default.Events.SESSION_REMOTE_STREAM, this._onRemoteStream.bind(this));
      session.on(_jsSdk2.default.Events.SESSION_PARTICIPANT_JOINED, this._onSessionParticipantJoined.bind(this));
      session.on(_jsSdk2.default.Events.SESSION_PARTICIPANT_LEFT, this._onSessionParticipantLeft.bind(this));
      session.on(_jsSdk2.default.Events.SESSION_ERROR, this._onError.bind(this));
      session.on(_jsSdk2.default.Events.SESSION_END, this._onSessionEnd.bind(this));
      session.on(_jsSdk2.default.Events.SESSION_SIP_STATUS, this._onSessionSIPStatus.bind(this));
      session.on(_jsSdk2.default.Events.SESSION_USER_PROFILE_CHANGE, this._onUserProfileChange.bind(this));
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      console.log(' 555RoomContainer :: componentWillMount');
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {

      console.log(' 555RoomContainer :: componentDidMount');

      var self = this;

      if (!this.props.Config || !this.props.Type || !this.props.RoomId) {
        console.warn("Please check the props");
      }

      if (this.props.Config) {
        console.log(' 555RoomContainer :: componentDidMount : IrisRtcConfig.updateConfig called');
      }

      if (this.props.Type && this.props.Config) {
        if (this.props.Type === 'video' && this.props.RoomId) {
          console.error("555RoomContainer :: componentDidMount :: video isn't supported yet");
        } else if (this.props.Type === 'audio' || this.props.Type === 'pstn') {

          if (!localStream) {
            console.error("555RoomContainer :: componentDidMount :: invalid stream");
            return;
          }

          // Create new session
          var config = self.props.Config;
          config.roomId = self.props.RoomId;
          config.type = self.props.Type;

          if (self.props.NotificationPayload) {

            console.log("555RoomContainer :: componentDidMount :: Joining audio/pstn call with RoomId " + self.props.RoomId + " config : " + JSON.stringify(config) + " notification " + JSON.stringify(self.props.NotificationPayload));

            var session = PSTN.accept(config, self.props.NotificationPayload);
            this.listenToSessionEvents(session);
          } else {

            if (this.props.Type === 'pstn') {
              console.log("555RoomContainer :: Making PSTN call with fromTN " + config.fromTN + " and toTN " + config.toTN);

              // Use new 555-js-sdk for pstn calls
              var session = PSTN.dial(config);
              this.listenToSessionEvents(session);
            } else {

              if (!this.props.RoomId) return;

              console.log("555RoomContainer :: componentDidMount :: Making audio/pstn call with RoomId " + self.props.RoomId + " config : " + JSON.stringify(config));
            }
          }
        } else if (this.props.Type === 'chat') {
          console.error("555RoomContainer :: componentDidMount :: chat isn't supported yet");
        } else {
          console.error("555RoomContainer :: componentDidMount :: type invalid " + this.props.Type);

          console.log("Error in componentDidMount");
        }
      }
    }

    // Called when there is a change in props

  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {

      console.log("555RoomContainer :: componentWillReceiveProps :: start");

      var self = this;

      if (!this.props.Type && !nextProps.Type || !this.props.Config && !nextProps.Config) {
        console.log("Type and Config are required to make a call");
        return;
      }

      var config = nextProps.Config;
      config.roomId = nextProps.RoomId;
      config.type = nextProps.Type;

      if (nextProps.Type === "pstn" && !self.callInProgress) {

        self.callInProgress = true;

        console.log("555RoomContainer :: PSTN Call ");

        if (nextProps.NotificationPayload) {
          console.log("555RoomContainer :: Joining PSTN call with RoomId " + nextProps.RoomId + " config : " + JSON.stringify(config) + " notification " + JSON.stringify(nextProps.NotificationPayload));

          var session = PSTN.accept(config, nextProps.NotificationPayload);
          this.listenToSessionEvents(session);
        } else {
          console.log("555RoomContainer :: Making PSTN call with fromTN " + config.fromTN + " and toTN " + config.toTN);
          if (localStream) {
            var session = PSTN.dial(config);
            this.listenToSessionEvents(session);
          } else {
            console.error("555RoomContainer ::  invalid stream");
          }
        }
      } else if (this.props.RoomId && !nextProps.RoomId) {

        console.log("555RoomContainer :: RoomId is set to null - ending the session");
        if (this.pstnSession) this.pstnSession.end(this.props.RoomId);
      } else if (this.props.RoomId === nextProps.RoomId && this.props.RoomId && nextProps.RoomId) {

        console.log("555RoomContainer :: RoomId is same - checking for Type change");

        // If RoomId is same and call Type has changed end the old session
        // and create new session with latest Type
        if (this.props.Type !== nextProps.Type) {

          console.log("555RoomContainer :: Change in the session Type is detected " + this.props.Type + " --> " + nextProps.Type);
        } else {
          // RoomId and Type both are same dont do anything
          console.log("555RoomContainer :: RoomId and Type both are NOT changed");
          if (!nextProps.Type) {
            // RoomId not changed and Type set to empty, Do we need to end session?
          }
        }
      } else if (this.props.RoomId !== nextProps.RoomId) {

        console.log("555RoomContainer :: Change in RoomId detected : " + this.props.RoomId + " --> " + nextProps.RoomId);

        // If RoomId is changed end the old session and
        // create new session with latest RoomId from props

        // Stop media stream and end the session

        if (this.props.RoomId) {
          if (this.pstnSession) this.pstnSession.end(this.props.RoomId);
        }

        if (nextProps.Type === "video") {

          console.error("555RoomContainer :: Video call not supported");
        } else if (nextProps.Type === 'chat') {
          console.error("555RoomContainer :: chat is not supported");
        } else if (nextProps.Type === "audio" || nextProps.Type === "pstn") {

          if (nextProps.Type === "pstn") {

            console.log("555RoomContainer :: PSTN call");

            if (nextProps.NotificationPayload) {
              console.log("555RoomContainer :: Joining audio call with RoomId " + nextProps.RoomId + " config : " + JSON.stringify(config) + " notification " + JSON.stringify(nextProps.NotificationPayload));

              var session = PSTN.accept(config, nextProps.NotificationPayload);
              this.listenToSessionEvents(session);
            } else {

              console.log("555RoomContainer :: Making PSTN call with fromTN " + config.fromTN + " and toTN " + config.toTN);

              if (localStream) {
                var session = PSTN.dial(config);
                this.listenToSessionEvents(session);
              } else {
                console.error("555RoomContainer :: invalid stream");
              }
            }
          } else if (nextProps.Type === "audio") {
            console.error("555RoomContainer :: audio call not supported yet");
          }
        }
      } else if (this.props.Type != nextProps.Type || this.props.RoomId != nextProps.RoomId) {
        console.log("555RoomContainer :: Change in Type and RoomId");

        if (this.props.Type == 'chat' && this.props.RoomId != "") {
          // End the existing session
          this.pstnSession.end(this.props.RoomId);
        }
      }

      console.log("555RoomContainer :: componentWillReceiveProps :: end");
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      console.log("555RoomContainer :: componentWillUnmount");
      this._endSession();
    }

    // Function end the session

  }, {
    key: '_endSession',
    value: function _endSession() {
      this.callInProgress = false;
      console.log("555RoomContainer :: _endSession : RoomId " + this.props.RoomId);

      // End the session
      if (this.pstnSession) {
        this.pstnSession.end(this.props.RoomId);
      }
    }
  }, {
    key: '_onLocalStream',
    value: function _onLocalStream(stream) {
      console.log("555RoomContainer :: _onLocalStream");
      this.localStream = stream;
      if (this.props.onLocalStream) {
        this.props.onLocalStream(stream);
      }
    }
  }, {
    key: '_onStreamStopped',
    value: function _onStreamStopped() {
      console.log("555RoomContainer :: _onStreamStopped");
      if (this.props.onStreamStopped) {
        this.props.onStreamStopped();
      }
    }
  }, {
    key: '_onRemoteStream',
    value: function _onRemoteStream(roomId, stream) {
      console.log("555RoomContainer :: _onRemoteStream :: roomId : " + roomId);
      if (this.props.onRemoteStream) {
        this.props.onRemoteStream(roomId, stream);
      }
    }
  }, {
    key: '_onSessionCreated',
    value: function _onSessionCreated(roomId, msg) {
      console.log("555RoomContainer :: _onSessionCreated " + roomId);
      if (this.props.onSessionCreated) {
        this.props.onSessionCreated(roomId, msg);
      }
    }
  }, {
    key: '_onSessionJoined',
    value: function _onSessionJoined(roomId, myJid) {
      console.log("RoomContainer :: _onSessionJoined : RoomId : " + roomId);
      if (this.props.onSessionJoined) {
        this.props.onSessionJoined(roomId, myJid);
      }
    }
  }, {
    key: '_onSessionConnected',
    value: function _onSessionConnected(roomId, myJid) {
      console.log("555RoomContainer :: _onSessionConnected " + roomId);
      if (this.props.onSessionConnected) {
        this.props.onSessionConnected(roomId, myJid);
      }
    }
  }, {
    key: '_onSessionParticipantJoined',
    value: function _onSessionParticipantJoined(roomId, participantJid) {
      console.log("555RoomContainer :: _onSessionParticipantJoined :: participantJid : " + participantJid);
      if (this.props.onSessionParticipantJoined) {
        this.props.onSessionParticipantJoined(roomId, participantJid);
      }
    }
  }, {
    key: '_onSessionParticipantLeft',
    value: function _onSessionParticipantLeft(roomId, participantJid, closeSession) {
      console.log("555RoomContainer :: _onSessionParticipantLeft :: participantJid : " + participantJid);
      if (this.props.onSessionParticipantLeft) {
        this.props.onSessionParticipantLeft(roomId, participantJid, closeSession);
      }
    }
  }, {
    key: '_onSessionEnd',
    value: function _onSessionEnd(roomId) {
      console.log("555RoomContainer :: _onSessionEnd : RoomId : " + roomId);
      if (this.props.onSessionEnd) {
        this.props.onSessionEnd(roomId);
      }
    }
  }, {
    key: '_onSessionParticipantAudioMuted',
    value: function _onSessionParticipantAudioMuted(roomId, id, muted) {
      console.log("555RoomContainer :: _onSessionParticipantAudioMuted " + id + " Muted " + muted);
      if (this.props.onSessionParticipantAudioMuted) {
        this.props.onSessionParticipantAudioMuted(roomId, id, muted);
      }
    }
  }, {
    key: '_onUserProfileChange',
    value: function _onUserProfileChange(roomId, id, obj) {
      console.log("555RoomContainer :: _onUserProfileChange " + id + " obj " + JSON.stringify(obj));
      if (this.props.onUserProfileChange) {
        this.props.onUserProfileChange(roomId, id, obj);
      }
    }
  }, {
    key: '_onError',
    value: function _onError(roomId, errorCode, errorMessage) {
      console.log("555RoomContainer :: onSesssionError " + error);
      if (this.props.onError) {
        this.props.onError(roomId, errorCode, errorMessage);
      }
    }
  }, {
    key: '_onEvent',
    value: function _onEvent(roomId, event) {
      console.log("555RoomContainer :: onEvent :: " + JSON.stringify(event));
      if (this.props.onEvent) {
        this.props.onEvent(event);
      }
    }
  }, {
    key: '_onSessionSIPStatus',
    value: function _onSessionSIPStatus(roomId, participantJid, status) {
      console.log("555RoomContainer :: _onSessionSIPStatus :: status : " + status);
      if (this.props.onSessionSIPStatus) {
        this.props.onSessionSIPStatus(roomId, participantJid, status);
      }
    }
  }, {
    key: 'endSession',
    value: function endSession(roomId) {
      this.callInProgress = false;
      console.log("555RoomContainer :: endSession : roomId " + roomId);
      if (this.pstnSession) {
        this.pstnSession.end(roomId);
      }
    }
  }, {
    key: 'audioMuteToggle',
    value: function audioMuteToggle(roomId) {
      console.log("555RoomContainer :: audioMuteToggle");
      if (this.pstnSession) {
        this.pstnSession.audioMuteToggle(roomId);
      }
    }
  }, {
    key: 'sendDTMFTone',
    value: function sendDTMFTone(roomId, tone, duration, interToneGap) {
      console.log("555RoomContainer :: sendDTMFTone");
      if (this.pstnSession) {
        this.pstnSession.sendDTMFTone(roomId, tone, duration, interToneGap);
      }
    }
  }, {
    key: 'pstnHold',
    value: function pstnHold(roomId, participantJid) {
      console.log("555RoomContainer :: pstnHold");
      if (this.pstnSession) {
        this.pstnSession.hold(roomId, participantJid);
      }
    }
  }, {
    key: 'pstnUnHold',
    value: function pstnUnHold(roomId, participantJid) {
      console.log("555RoomContainer :: pstnUnHold");
      if (this.pstnSession) {
        this.pstnSession.unhold(roomId, participantJid);
      }
    }
  }, {
    key: 'pstnHangup',
    value: function pstnHangup(roomId, participantJid) {
      console.log("555RoomContainer :: pstnHangup");
      this.callInProgress = false;
      if (this.pstnSession) {
        this.pstnSession.hangup(roomId, participantJid);
      }
    }
  }, {
    key: 'pstnMerge',
    value: function pstnMerge(roomId, firstParticipantJid, secondSession, secondParticipantJid) {
      console.log("555RoomContainer :: pstnMerge");
      if (this.pstnSession) {
        this.pstnSession.pstnMerge(roomId, firstParticipantJid, secondSession, secondParticipantJid);
      }
    }
  }, {
    key: 'getRealTimeStats',
    value: function getRealTimeStats(roomId) {
      return this.pstnSession.getRealTimeStats(roomId);
    }
  }, {
    key: 'render',
    value: function render() {
      var videoCallView = _react2.default.createElement(VideoCallView, this.props);
      if (this.props.Type == 'video') return videoCallView;else return _react2.default.createElement('div', null);
    }
  }]);

  return RoomContainer;
}(_react.Component);

var VideoCallView = function (_Component2) {
  _inherits(VideoCallView, _Component2);

  function VideoCallView(props) {
    _classCallCheck(this, VideoCallView);

    return _possibleConstructorReturn(this, (VideoCallView.__proto__ || Object.getPrototypeOf(VideoCallView)).call(this, props));
  }

  _createClass(VideoCallView, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement('div', { className: 'iris-room' });
    }
  }]);

  return VideoCallView;
}(_react.Component);

exports.RoomContainer = RoomContainer;
exports.RtcSdk = RtcSdk;
exports.default = RtcSdk;